'---LOTTERY NUMBER CHECKER BY D.GRAHAM----
'---------Version 3.1---28/08/97----------

'lnc_3_1.zip

'Contents:
'   lnc.bas   - Lottery checker qbasic program
'   lnc.txt   - syndicate numbers template
'   stats.txt - syndicate statistics template
'   lnc.ico   - icon for program manager
'   lnc.bmp   - bmp for msoffice toolbar

'Create directory in C:\ called LOTTERY
'Place all files (except lnc.bmp) in C:\LOTTERY
'place LNC.BMP in C:\MSOFFICE\MS_BTTNS

'This program reads in the numbers for the syndicate from the file
'lottery.txt,
'first line is the number of people in the syndicate
'   n
'Next the syndicate numbers: up to 10 characters enclosed in speech
'marks followed by the numbers separated with commas:
'   "name.....",a,b,c,d,e,f
'   "name2....",g,h,i,j,k,l
'    etc

'-----------subroutines-------------------
DECLARE SUB numbers ()
DECLARE SUB todaysnumbers ()
DECLARE SUB check ()
DECLARE SUB newstats ()
DECLARE SUB dispmatchnumbers ()
DECLARE SUB displaystats ()
DECLARE SUB updatestats ()
DECLARE SUB resetstats ()
DECLARE SUB viewlottnumbers ()
DECLARE SUB changenumbers ()
DECLARE SUB addperson ()
DECLARE SUB deleteperson ()
DECLARE SUB league ()
DECLARE SUB mainscreen ()

'-----------variables---------------------
DIM SHARED b, I, N
DIM SHARED x(30), flag(30), leaguetable(30), stat(30)
DIM SHARED a(30, 7), order(30)
DIM SHARED white, cyan, yellow
DIM SHARED k(30) AS STRING, l(30) AS STRING, leaguename(30) AS STRING
DIM SHARED count(30, 7), o(30, 7), in(30, 7), d(30, 7)
DIM SHARED answer, new
DIM SHARED total(30, 7), leaguestats(30, 7)


'----------screen mode&colours------------
SCREEN 12
white = 15
yellow = 14
cyan = 3
'---------load numbers and stats----------
'load numbers
ON ERROR GOTO nolotteryfile
OPEN "c:\lottery\lottery.txt" FOR INPUT AS #1
INPUT #1, N

 FOR I = 1 TO N
  INPUT #1, l(I)
  FOR b = 1 TO 6
   INPUT #1, a(I, b)
  NEXT b
 NEXT I
 CLOSE #1
'----------------------------
'load stats
 ON ERROR GOTO nostatsfile
 OPEN "c:\lottery\stats.txt" FOR INPUT AS #1
 INPUT #1, l(0)
 FOR I = 1 TO N
   INPUT #1, k(I)
  FOR b = 1 TO 7
   INPUT #1, in(I, b)
  NEXT b
 NEXT I
 CLOSE #1

'----------------main menu----------------
ON ERROR GOTO help
1
CALL mainscreen
PRINT "Select one of the following options"
PRINT "1. Check lottery numbers"
PRINT "2. View/update/reset statistics"
PRINT "3. View/edit lottery numbers"
PRINT "4. Exit"
PRINT "Press the number of the option you require"

DO
 a$ = INKEY$
 IF a$ = CHR$(49) THEN GOTO 10
 IF a$ = CHR$(50) THEN GOTO 20
 IF a$ = CHR$(51) THEN GOTO 30
 IF a$ = CHR$(52) THEN STOP
LOOP UNTIL false

'-----------Check lottery numbers---------
10
 CLS
 CALL todaysnumbers
 CALL check
 CALL dispmatchnumbers
 new = 1
 GOTO 1

'-----------Statistics Menu---------------
20
 CALL mainscreen
 PRINT "Select one of the following"
 PRINT "1. View current statisics"
 PRINT "2. Update statistics"
 PRINT "3. Reset all Statistics"
 PRINT "4. View league table"
 PRINT "5. Return to main menu."

 CALL newstats
 DO
  a$ = INKEY$
  IF a$ = CHR$(49) THEN CALL displaystats: GOTO 20
  IF a$ = CHR$(50) THEN CALL updatestats: GOTO 20
  IF a$ = CHR$(51) THEN CALL resetstats: GOTO 20
  IF a$ = CHR$(52) THEN CALL league: GOTO 20
  IF a$ = CHR$(53) THEN GOTO 1
 LOOP UNTIL false

'-------View/Edit lottery numbers---------
30
 CALL mainscreen
 PRINT "Select one of the following options"
 PRINT "1. View lottery numbers"
 PRINT "2. Change numbers"
 PRINT "3. Add a person"
 PRINT "4. Delete a person"
 PRINT "5. Return to main menu."
 
 DO
  a$ = INKEY$
  IF a$ = CHR$(49) THEN CALL viewlottnumbers: GOTO 30
  IF a$ = CHR$(50) THEN CALL changenumbers: GOTO 30
  IF a$ = CHR$(51) THEN CALL addperson: GOTO 30
  IF a$ = CHR$(52) THEN CALL deleteperson: GOTO 30
  IF a$ = CHR$(53) THEN GOTO 1
 LOOP UNTIL false

GOTO 30

nolotteryfile:
 PRINT "On or more files are not present in c:\lottery directory"
 PRINT "You must either:"
 PRINT "1. Create new files for Lottery numbers and Statistics"
 PRINT "2. Quit program"

 INPUT "option="; answer
 IF answer = 1 THEN GOTO newlotteryfile ELSE STOP
RESUME
 
newlotteryfile:
 INPUT "Enter the number of people in the syndicate,"; N$
 IF LEN(N$) = 0 THEN GOTO newlotteryfile
 N = VAL(N$)

 FOR I = 1 TO N
  PRINT "No."; I; " ,Name="; : INPUT l(I)
  FOR b = 1 TO 6
   PRINT "number"; b; "="; : INPUT a(I, b)
  NEXT b
 NEXT I
'--writing to disk--
 OPEN "c:\lottery\lottery.txt" FOR OUTPUT AS #1
 WRITE #1, N
 FOR I = 1 TO N
  WRITE #1, l(I), a(I, 1), a(I, 2), a(I, 3), a(I, 4), a(I, 5), a(I, 6)
 NEXT I
 CLOSE #1
'--creating stats file--
nostatsfile:
 OPEN "c:\lottery\stats.txt" FOR OUTPUT AS #2
 WRITE #2, "No. Balls:  1 2 3 4 5 6 5B"
 FOR I = 1 TO N
  WRITE #2, l(I), 0, 0, 0, 0, 0, 0, 0
 NEXT I
 CLOSE #2

RESUME
GOTO 30
help:
 PRINT "Error encountered"
 PRINT "press enter to restart program or esc to quit"
 DO
 IF INKEY$ = CHR$(13) THEN GOTO 1
 IF INKEY$ = CHR$(26) THEN STOP
 LOOP UNTIL false
GOTO 30

STOP

SUB addperson
CALL mainscreen
PRINT "please type in the name of the person (Up to 10 characters max)"
PRINT "completely fill remaining blanks using full stops please"
INPUT l(N + 1)

PRINT "Type in their 6 lottery numbers"
FOR b = 1 TO 6
 INPUT a((N + 1), b)
NEXT b

PRINT "Do you wish to go ahead with changes (Y/N)?"
DO
 a$ = INKEY$
 IF a$ = CHR$(78) OR a$ = CHR$(110) THEN EXIT SUB
 IF a$ = CHR$(89) OR a$ = CHR$(121) THEN GOTO 90
LOOP UNTIL false

90
OPEN "c:\lottery\lottery.txt" FOR OUTPUT AS #1
N = N + 1
WRITE #1, N
FOR I = 1 TO N
 WRITE #1, l(I), a(I, 1), a(I, 2), a(I, 3), a(I, 4), a(I, 5), a(I, 6)
NEXT I
CLOSE #1

OPEN "c:\lottery\stats.txt" FOR APPEND AS #1
WRITE #1, l(N), 0, 0, 0, 0, 0, 0, 0
CLOSE #1

PRINT l(N + 1); " has been added"
PRINT "Press any key to return to menu options"

DO UNTIL INKEY$ <> ""
a$ = INKEY$
LOOP

END SUB

SUB backupstats

OPEN "c:\lottery\stats.bak" FOR OUTPUT AS #1

WRITE #2, l(0)
FOR I = 1 TO N
  WRITE #2, k(I)
 FOR b = 1 TO 7
  WRITE #2, in(I, b)
 NEXT b
NEXT I
CLOSE #1
END SUB

SUB changenumbers
CALL numbers
CALL mainscreen

FOR I = 1 TO N
 IF I < 10 THEN PRINT I; ".."; l(I);
 IF I >= 10 THEN PRINT I; "."; l(I);
FOR b = 1 TO 6
  IF a(I, b) < 10 THEN PRINT " "; a(I, b);
  IF a(I, b) >= 10 THEN PRINT a(I, b);
 NEXT b
PRINT
NEXT I

PRINT "Enter the number of the line which";
PRINT " contains the numbers you wish to change"
INPUT q

PRINT " Type in the new numbers pressing enter after each number in turn"
FOR b = 1 TO 6
 INPUT a(q, b)
NEXT b

PRINT "Go ahead with changes? (Y/N)"
DO
a$ = INKEY$
IF a$ = CHR$(78) OR a$ = CHR$(110) THEN EXIT SUB
IF a$ = CHR$(89) OR a$ = CHR$(121) THEN GOTO 70
LOOP UNTIL false

70
OPEN "c:\lottery\lottery.txt" FOR OUTPUT AS #1
WRITE #1, N
FOR I = 1 TO N
 WRITE #1, l(I), a(I, 1), a(I, 2), a(I, 3), a(I, 4), a(I, 5), a(I, 6)
NEXT I
CLOSE #1
PRINT "Numbers have been changed"
PRINT "press any key to return to menu options"

DO UNTIL INKEY$ <> ""
a$ = INKEY$
LOOP

END SUB

SUB check

FOR I = 1 TO N
 stat(I) = 0
 FOR b = 1 TO 7
  d(I, b) = 0
 NEXT b
NEXT I
FOR I = 1 TO N
 FOR b = 1 TO 6
  FOR c = 1 TO 7
   IF a(I, b) = x(c) THEN d(I, b) = x(c)
   IF a(I, b) = x(c) THEN stat(I) = stat(I) + 1
   IF d(I, b) = x(7) THEN stat(I) = stat(I) - 1
   IF d(I, b) = x(7) THEN flag(I) = 1 ELSE flag(I) = 0
  NEXT c
 NEXT b
NEXT I

END SUB

SUB deleteperson
CALL mainscreen

FOR I = 1 TO N
 IF I < 10 THEN PRINT I; ".."; l(I);
 IF I >= 10 THEN PRINT I; "."; l(I);
FOR b = 1 TO 6
  IF a(I, b) < 10 THEN PRINT a(I, b); " ";
  IF a(I, b) >= 10 THEN PRINT a(I, b);
 NEXT b
PRINT
NEXT I

PRINT "Enter the number of the person to be removed"
INPUT answer
PRINT "Go ahead with removal? (Y/N)"
DO
 a$ = INKEY$
 IF a$ = CHR$(78) OR a$ = CHR$(110) THEN EXIT SUB
 IF a$ = CHR$(89) OR a$ = CHR$(121) THEN GOTO 60
LOOP UNTIL false

60
OPEN "c:\lottery\lottery.txt" FOR OUTPUT AS #1
OPEN "c:\lottery\stats.txt2" FOR OUTPUT AS #2
N = N - 1
WRITE #1, N
FOR I = 1 TO (answer - 1)
 WRITE #1, l(I), a(I, 1), a(I, 2), a(I, 3), a(I, 4), a(I, 5), a(I, 6)
 WRITE #2, l(I), in(I, 1), in(I, 2), in(I, 3), in(I, 4), in(I, 5), in(I, 6), in(I, 7)
NEXT I
FOR I = (answer + 1) TO (N + 1)
 WRITE #1, l(I), a(I, 1), a(I, 2), a(I, 3), a(I, 4), a(I, 5), a(I, 6)
 WRITE #2, l(I), in(I, 1), in(I, 2), in(I, 3), in(I, 4), in(I, 5), in(I, 6), in(I, 7)
NEXT I
CLOSE #1
CLOSE #2
PRINT No.; ";answer;"; has; been; removed; ""
PRINT "Press any key to return to menu options"
DO UNTIL INKEY$ <> ""
a$ = INKEY$
LOOP


END SUB

SUB displaystats
CALL mainscreen

PRINT "Statistics"
COLOR cyan
PRINT "No. balls:  1   2   3   4   5   6  5+b"
COLOR white
FOR I = 1 TO N
 PRINT l(I);
 FOR b = 1 TO 7

  IF new = 1 AND o(I, b) < 10 THEN PRINT " "; o(I, b);
  IF new = 1 AND o(I, b) >= 10 THEN PRINT o(I, b);
  IF new = 0 AND in(I, b) < 10 THEN PRINT " "; in(I, b);
  IF new = 0 AND in(I, b) >= 10 THEN PRINT in(I, b);
 NEXT b
 PRINT
NEXT I
PRINT "Press any key to return to menu options"
DO UNTIL INKEY$ <> ""
a$ = INKEY$
LOOP
END SUB

SUB dispmatchnumbers
CALL mainscreen

PRINT "THE MATCHING NUMBERS ARE:"
PRINT "The number in yellow is the bonus ball"
FOR I = 1 TO N
 COLOR cyan
 IF stat(I) = 5 AND flag(I) = 1 THEN bb = 1 ELSE bb = 0
 IF stat(I) >= 3 AND bb = 0 THEN PRINT l(I); " has got"; stat(I); "numbers!"
 IF bb = 1 THEN PRINT l(I); " has got"; stat(I); "numbers and the Bonus Ball!"
 COLOR white
 PRINT l(I); "=";
 FOR b = 1 TO 7
   IF d(I, b) = x(7) THEN COLOR yellow
   IF d(I, b) = 0 THEN PRINT "";  ELSE PRINT d(I, b);
   IF d(I, b) > 0 THEN PRINT " ";  ELSE PRINT ;
   COLOR white
 NEXT b
 PRINT
NEXT I
PRINT "press any key to return to main menu"

DO UNTIL INKEY$ <> ""
a$ = INKEY$
LOOP

END SUB

SUB league
REM this sub produces a league table in order of the most successfull
CALL mainscreen

PRINT "League Table"
FOR I = 1 TO N
  leaguetable(I) = 0
NEXT I

IF new = 1 THEN GOTO 123

REM--------------------------------------

FOR I = 1 TO N
 FOR b = 1 TO 7
  leaguetable(I) = 100 ^ (b - 1) * in(I, b) + leaguetable(I)
 NEXT b
NEXT I
GOTO 130
REM--------------------------------------
123
FOR I = 1 TO N
 FOR b = 1 TO 7
  leaguetable(I) = 100 ^ (b - 1) * o(I, b) + leaguetable(I)
 NEXT b
NEXT I
130
REM---------generating league------------
rank = 1

FOR z = 1 TO N
 old = 0
 max = 0

 FOR I = 1 TO N
  newt = leaguetable(I)
   IF newt > old THEN max = newt
  old = max
 NEXT I

 FOR I = 1 TO N
  IF max = leaguetable(I) THEN leaguename(z) = l(I)
  IF max = leaguetable(I) THEN rank = I
 NEXT I

 FOR b = 1 TO 7
  IF new = 0 THEN leaguestats(z, b) = in(rank, b)
  IF new = 1 THEN leaguestats(z, b) = o(rank, b)
 NEXT b

 leaguetable(rank) = 0
 rank = rank + 1
NEXT z

REM------displaying league table----------

COLOR cyan
PRINT "Rank Name       1   2   3   4   5   6  5+B"
COLOR white
FOR I = 1 TO N
 IF I < 10 THEN PRINT " "; I; leaguename(I);
 IF I >= 10 THEN PRINT I; leaguename(I);
  FOR b = 1 TO 7
   IF new = 1 AND leaguestats(I, b) < 10 THEN PRINT " "; leaguestats(I, b);
   IF new = 0 AND leaguestats(I, b) < 10 THEN PRINT " "; leaguestats(I, b);
   IF new = 1 AND leaguestats(I, b) >= 10 THEN PRINT ""; leaguestats(I, b);
   IF new = 0 AND leaguestats(I, b) >= 10 THEN PRINT ""; leaguestats(I, b);
  NEXT b
 PRINT
NEXT I

REM---------------------------------------
PRINT "Press any key to return to menu"

DO UNTIL INKEY$ <> ""
 a$ = INKEY$
LOOP

END SUB

SUB mainscreen
CLS
PRINT "ͻ"
PRINT " Lottery Number Cruncher "
PRINT "    by D.Graham V3.0     "
PRINT "ͼ"
PRINT
END SUB

SUB newstats

FOR I = 1 TO N
 FOR b = 1 TO 6
  total(I, b) = 0
 NEXT b
NEXT I

FOR I = 1 TO N
 FOR b = 1 TO 6
  IF stat(I) = b THEN LET total(I, b) = total(I, b) + 1
  IF d(I, b) = x(7) AND stat(I) = 5 THEN LET total(I, 7) = total(I, 7) + 1
 NEXT b
NEXT I

FOR I = 1 TO N
 FOR b = 1 TO 7
   o(I, b) = in(I, b) + total(I, b)
 NEXT b
NEXT I

END SUB

SUB numbers
OPEN "c:\lottery\lottery.txt" FOR INPUT AS #1
INPUT #1, N
 FOR I = 1 TO N
  INPUT #1, l(I)
  FOR b = 1 TO 6
   INPUT #1, a(I, b)
  NEXT b
 NEXT I
 CLOSE #1

END SUB

SUB resetstats
CALL mainscreen

PRINT "Are you sure you want to reset all statistics? (Y/N)"
DO
 a$ = INKEY$
 IF a$ = CHR$(78) OR a$ = CHR$(110) THEN EXIT SUB
 IF a$ = CHR$(89) OR a$ = CHR$(121) THEN GOTO 80
LOOP UNTIL false

80
OPEN "c:\lottery\stats.txt" FOR OUTPUT AS #4
WRITE #4, "No. Balls:  1 2 3 4 5 6 5B"
FOR I = 1 TO N
 WRITE #4, l(I), 0, 0, 0, 0, 0, 0, 0
NEXT I
CLOSE #4
PRINT "Stats have been reset to zero"
PRINT "Press any key to return to menu"

DO UNTIL INKEY$ <> ""
 a$ = INKEY$
LOOP

END SUB

SUB todaysnumbers
CALL mainscreen

PRINT "Please enter the lottery numbers"
FOR I = 1 TO 6
 PRINT "No."; I; "="; : INPUT x(I)
NEXT I
PRINT "Bonus Ball"; "="; : INPUT x(7)

END SUB

SUB updatestats
CALL mainscreen

PRINT "Are you sure you want to update stats? (Y/N)"
DO
 a$ = INKEY$
 IF a$ = CHR$(78) OR a$ = CHR$(110) THEN EXIT SUB
 IF a$ = CHR$(89) OR a$ = CHR$(121) THEN GOTO 50
LOOP UNTIL false

50
OPEN "c:\lottery\stats.txt" FOR OUTPUT AS #3
WRITE #3, l(0)
FOR I = 1 TO N
  WRITE #3, k(I), o(I, 1), o(I, 2), o(I, 3), o(I, 4), o(I, 5), o(I, 6), o(I, 7)
NEXT I
CLOSE #3

PRINT "Stats have been updated"
PRINT "Press any key to return to menu options"
DO UNTIL INKEY$ <> ""
 a$ = INKEY$
LOOP

END SUB

SUB viewlottnumbers
CALL mainscreen

FOR I = 1 TO N
 IF I < 10 THEN PRINT "  "; I; l(I);
 IF I >= 10 THEN PRINT " "; I; l(I);
FOR b = 1 TO 6
  IF a(I, b) < 10 THEN PRINT " "; a(I, b);
  IF a(I, b) >= 10 THEN PRINT a(I, b);
 NEXT b
PRINT
NEXT I
PRINT "Press any key to return to menu"
DO UNTIL INKEY$ <> ""
a$ = INKEY$
LOOP

END SUB

